'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var MuiAlert = require('@mui/material/Alert');
var Slide = require('@mui/material/Slide');
var Snackbar = require('@mui/material/Snackbar');
var material = require('@mui/material');
var Box = require('@mui/system/Box');
var styles = require('@mui/material/styles');
var LinearProgress = require('@mui/material/LinearProgress');
var Box$1 = require('@mui/material/Box');
var Button = require('@mui/material/Button');
var Dialog = require('@mui/material/Dialog');
var DialogActions = require('@mui/material/DialogActions');
var DialogContent = require('@mui/material/DialogContent');
var DialogContentText = require('@mui/material/DialogContentText');
var DialogTitle = require('@mui/material/DialogTitle');
var Stack = require('@mui/material/Stack');
var reactFontawesome = require('@fortawesome/react-fontawesome');
var fontawesomeSvgCore = require('@fortawesome/fontawesome-svg-core');
var freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');
var Typography = require('@mui/material/Typography');
var Grid = require('@mui/material/Grid');
var Popover = require('@mui/material/Popover');
var system = require('@mui/system');
var Paper = require('@mui/material/Paper');
var IconButton = require('@mui/material/IconButton');
var CloseIcon = require('@mui/icons-material/Close');
var MobileDatePicker = require('@mui/x-date-pickers/MobileDatePicker');
var LocalizationProvider = require('@mui/x-date-pickers/LocalizationProvider');
var AdapterMoment = require('@mui/x-date-pickers/AdapterMoment');
var TextField = require('@mui/material/TextField');
var moment = require('moment');
var Autocomplete = require('@mui/material/Autocomplete');
var CircularProgress = require('@mui/material/CircularProgress');
var ClickAwayListener = require('@mui/material/ClickAwayListener');
var PersonSearchIcon = require('@mui/icons-material/PersonSearch');
var MapTwoToneIcon = require('@mui/icons-material/MapTwoTone');
var CorporateFareIcon = require('@mui/icons-material/CorporateFare');
var CardHeader = require('@mui/material/CardHeader');
var Avatar = require('@mui/material/Avatar');
var LocationOnTwoToneIcon = require('@mui/icons-material/LocationOnTwoTone');
var colors = require('@mui/material/colors');
var toolkit = require('@reduxjs/toolkit');
var Divider = require('@mui/material/Divider');
var EditIcon = require('@mui/icons-material/Edit');
var xDataGridPro = require('@mui/x-data-grid-pro');
var nerdNetwork = require('@nerdjs/nerd-network');
var DatePicker = require('@mui/x-date-pickers/DatePicker');
var TablePagination = require('@mui/material/TablePagination');
var useMediaQuery = require('@mui/material/useMediaQuery');
var Pagination = require('@mui/material/Pagination');
var iconsMaterial = require('@mui/icons-material');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var MuiAlert__default = /*#__PURE__*/_interopDefaultLegacy(MuiAlert);
var Slide__default = /*#__PURE__*/_interopDefaultLegacy(Slide);
var Snackbar__default = /*#__PURE__*/_interopDefaultLegacy(Snackbar);
var Box__default = /*#__PURE__*/_interopDefaultLegacy(Box);
var LinearProgress__default = /*#__PURE__*/_interopDefaultLegacy(LinearProgress);
var Box__default$1 = /*#__PURE__*/_interopDefaultLegacy(Box$1);
var Button__default = /*#__PURE__*/_interopDefaultLegacy(Button);
var Dialog__default = /*#__PURE__*/_interopDefaultLegacy(Dialog);
var DialogActions__default = /*#__PURE__*/_interopDefaultLegacy(DialogActions);
var DialogContent__default = /*#__PURE__*/_interopDefaultLegacy(DialogContent);
var DialogContentText__default = /*#__PURE__*/_interopDefaultLegacy(DialogContentText);
var DialogTitle__default = /*#__PURE__*/_interopDefaultLegacy(DialogTitle);
var Stack__default = /*#__PURE__*/_interopDefaultLegacy(Stack);
var Typography__default = /*#__PURE__*/_interopDefaultLegacy(Typography);
var Grid__default = /*#__PURE__*/_interopDefaultLegacy(Grid);
var Popover__default = /*#__PURE__*/_interopDefaultLegacy(Popover);
var Paper__default = /*#__PURE__*/_interopDefaultLegacy(Paper);
var IconButton__default = /*#__PURE__*/_interopDefaultLegacy(IconButton);
var CloseIcon__default = /*#__PURE__*/_interopDefaultLegacy(CloseIcon);
var TextField__default = /*#__PURE__*/_interopDefaultLegacy(TextField);
var moment__default = /*#__PURE__*/_interopDefaultLegacy(moment);
var Autocomplete__default = /*#__PURE__*/_interopDefaultLegacy(Autocomplete);
var CircularProgress__default = /*#__PURE__*/_interopDefaultLegacy(CircularProgress);
var ClickAwayListener__default = /*#__PURE__*/_interopDefaultLegacy(ClickAwayListener);
var PersonSearchIcon__default = /*#__PURE__*/_interopDefaultLegacy(PersonSearchIcon);
var MapTwoToneIcon__default = /*#__PURE__*/_interopDefaultLegacy(MapTwoToneIcon);
var CorporateFareIcon__default = /*#__PURE__*/_interopDefaultLegacy(CorporateFareIcon);
var CardHeader__default = /*#__PURE__*/_interopDefaultLegacy(CardHeader);
var Avatar__default = /*#__PURE__*/_interopDefaultLegacy(Avatar);
var LocationOnTwoToneIcon__default = /*#__PURE__*/_interopDefaultLegacy(LocationOnTwoToneIcon);
var Divider__default = /*#__PURE__*/_interopDefaultLegacy(Divider);
var EditIcon__default = /*#__PURE__*/_interopDefaultLegacy(EditIcon);
var TablePagination__default = /*#__PURE__*/_interopDefaultLegacy(TablePagination);
var useMediaQuery__default = /*#__PURE__*/_interopDefaultLegacy(useMediaQuery);
var Pagination__default = /*#__PURE__*/_interopDefaultLegacy(Pagination);

const BorderLinearProgress = styles.styled((props) => {
    var _a;
    return (React__default["default"].createElement(LinearProgress__default["default"], { variant: props.variant, value: props.value, color: (_a = props.color) !== null && _a !== void 0 ? _a : "info" }));
})(({ theme }) => ({
    height: 5,
    borderRadius: 5,
    [`&.${LinearProgress.linearProgressClasses.colorPrimary}`]: {
        backgroundColor: theme.palette.grey[theme.palette.mode === "light" ? 200 : 800],
    },
    [`& .${LinearProgress.linearProgressClasses.bar}`]: {
        borderRadius: 5,
        backgroundColor: theme.palette.mode === "light" ? "#1a90ff" : "#308fe8",
    },
}));

let direction = undefined;
/**
 *
 * @param {NerdNotificationProps & openHookAction} param0 components props
 * @returns {JSX.Element} NonIntrusive nerdNotifier
 */
function NonIntrusive({ uuid, title, transition = "up", severity = "info", subtitle, body, position = {
    vertical: "bottom",
    horizontal: "right",
}, actions, autoHideDuration = 5000, autohide = true, open, handleClose, icon, color, }) {
    direction = transition;
    const [progress, setProgress] = React__default["default"].useState(0);
    const timer = React__default["default"].useRef(0);
    React__default["default"].useEffect(() => {
        timer.current = window.setInterval(() => {
            setProgress((prevProgress) => prevProgress >= 100 ? 0 : prevProgress + 10);
        }, autoHideDuration / 10);
        return () => {
            clearInterval(timer.current);
        };
    }, []);
    React__default["default"].useEffect(() => {
        if (progress >= 100 && autohide) {
            handleClose();
        }
    }, [progress, autohide]);
    if (icon) {
        return (React__default["default"].createElement(Alert, { severity: "warning", className: "nonIntrusive--unkown" }, "Unkown"));
    }
    return (React__default["default"].createElement(Box__default["default"], { component: "div", id: uuid },
        React__default["default"].createElement(Snackbar__default["default"], { open: open, autoHideDuration: autohide ? autoHideDuration : null, TransitionComponent: Transition, anchorOrigin: position },
            React__default["default"].createElement(material.Stack, { spacing: 1 },
                autohide && (React__default["default"].createElement(BorderLinearProgress, { variant: "determinate", value: progress, color: severity })),
                React__default["default"].createElement(Alert, { severity: severity, sx: { width: "100%", alignItems: "center", backgroundColor: color }, action: actions, onClose: handleClose },
                    title && React__default["default"].createElement(material.Typography, { variant: "body1" }, title),
                    subtitle && React__default["default"].createElement(material.Typography, { variant: "body2" }, subtitle),
                    body && React__default["default"].createElement(material.Typography, { variant: "caption" }, body))))));
}
const Alert = React__default["default"].forwardRef(function Alert(props, ref) {
    return React__default["default"].createElement(MuiAlert__default["default"], Object.assign({ ref: ref, variant: "filled" }, props));
});
/**
 *
 * @param {TransitionProps} props Component props
 * @returns {JSX.Element} Transition Component
 */
function Transition(props) {
    return React__default["default"].createElement(Slide__default["default"], Object.assign({}, props, { direction: direction }));
}

fontawesomeSvgCore.library.add(freeSolidSvgIcons.fas);
/**
 * This component is a wrapper for the FontAwesomeIcon component.
 * It is used to add icons to any library. More info here: https://fontawesome.com/v5/docs/web/use-with/react
 */
const NerdIcon = (props) => {
    const { icon, severity, iconColor, size = "3x", onMouseEnter, onMouseLeave, } = props;
    if (!icon) {
        return null;
    }
    return (React__default["default"].createElement("span", { onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave }, typeof icon === "string" ? (setCustomIconString(Object.assign({ icon, severity, iconColor, size }))) : (React__default["default"].createElement(reactFontawesome.FontAwesomeIcon, { icon: icon, size: size, color: iconColor !== null && iconColor !== void 0 ? iconColor : "#0288d1" }))));
};
/**
 *
 * @param root0
 * @param root0.icon
 * @param root0.iconColor
 * @param root0.severity
 * @param root0.size
 */
function setCustomIconString({ icon, iconColor, severity, size = "3x", }) {
    return (React__default["default"].createElement(reactFontawesome.FontAwesomeIcon, { icon: setCustomIconDefinition(icon), color: iconColor && iconColor !== ""
            ? iconColor
            : colorSwitch(severity || "info"), size: size }));
}
//TODO: fontawesome-svg-core package needs to be updated. (v5.15.4 current version). The icons name are were changed.
/**
 *
 * @param icon
 */
function setCustomIconDefinition(icon) {
    const iconLookup = {
        prefix: "fas",
        iconName: icon,
    };
    const customIconDefinition = fontawesomeSvgCore.findIconDefinition(iconLookup);
    return customIconDefinition;
}
/**
 *
 * @param color
 */
function colorSwitch(color) {
    switch (color) {
        case "error":
            return "#d32f2f";
        case "info":
            return "#0288d1";
        case "success":
            return "#2e7d32";
        case "warning":
            return "#ed6c02";
        default:
            return "#000";
    }
}

/**
 *
 * @param {NerdNotificationProps & openHookAction} param0 Component props
 * @returns {JSX.Element} Intrusive nerdNotifier
 */
function Intrusive({ title, subtitle, body, icon, actions, severity = "info", open, iconColor, autoHideDuration = 5000, autohide = true, showIcon = true, onHandleClose, unstyled = true, actionPrimaryProps = {
    variant: "text",
    color: "primary",
}, actionSecondaryProps = {
    variant: "text",
    color: "inherit",
}, }) {
    var _a;
    const [progress, setProgress] = React__default["default"].useState(0);
    const timer = React__default["default"].useRef(0);
    const handleClose = (_event, reason) => {
        if (reason === "clickaway" ||
            reason === "escapeKeyDown" ||
            reason === "backdropClick") {
            return;
        }
        onHandleClose(false);
    };
    React__default["default"].useEffect(() => {
        timer.current = window.setInterval(() => {
            setProgress((prevProgress) => prevProgress >= 100 ? 0 : prevProgress + 10);
        }, autoHideDuration / 10);
        return () => {
            clearInterval(timer.current);
        };
    }, []);
    React__default["default"].useEffect(() => {
        if (progress >= 100 && autohide) {
            onHandleClose(false);
        }
    }, [progress, autohide, open]);
    const severityIcon = setCustomIconDefinition(((_a = severityIcons(severity)) !== null && _a !== void 0 ? _a : "exclamation-circle"));
    return (React__default["default"].createElement(Dialog__default["default"], { open: open, onClose: handleClose, "aria-labelledby": "alert-dialog-title", "aria-describedby": "alert-dialog-description", keepMounted: true, transitionDuration: 1000, classes: {
            paper: "NerdNotifierIntrusivePaper",
        } },
        React__default["default"].createElement(Stack__default["default"], { spacing: 1 },
            autohide && !actions && (React__default["default"].createElement(BorderLinearProgress, { variant: "determinate", value: progress, color: severity })),
            showIcon && (React__default["default"].createElement(Box__default$1["default"], { className: "IntrusiveIcon" },
                typeof icon === "string" ? (React__default["default"].createElement(NerdIcon, { icon: severityIcon, severity: severity, iconColor: iconColor })) : (icon),
                severity && !icon && (React__default["default"].createElement(NerdIcon, { icon: severityIcon, severity: severity, iconColor: colorSwitch(severity) })))),
            title && React__default["default"].createElement(DialogTitle__default["default"], { id: "alert-dialog-title" }, title),
            unstyled ? (React__default["default"].createElement(DialogContent__default["default"], null,
                subtitle && (React__default["default"].createElement(DialogContentText__default["default"], { id: "alert-dialog-description" }, subtitle)),
                body)) : (React__default["default"].createElement(React__default["default"].Fragment, null,
                subtitle,
                body)),
            !autohide && (React__default["default"].createElement(DialogActions__default["default"], null,
                React__default["default"].createElement(Button__default["default"], Object.assign({ onClick: handleClose }, actionSecondaryProps), "Cancel"),
                React__default["default"].createElement(Button__default["default"], Object.assign({ onClick: handleClose }, actionPrimaryProps), "Ok"))))));
}
/**
 *
 * @param severityText
 */
function severityIcons(severityText) {
    switch (severityText) {
        case "error":
            return "times";
        case "info":
            return "exclamation";
        case "success":
            return "check";
        case "warning":
            return "exclamation-triangle";
        default:
            return "";
    }
}

// Generated with util/create-component.js
const NerdNotifier = (props) => {
    const { notification, children, onClose } = props;
    const { variant = "non-intrusive", uuid } = notification;
    const [open, setOpen] = React__default["default"].useState(false);
    React__default["default"].useEffect(() => {
        if (uuid) {
            setOpen(true);
        }
    }, [uuid]);
    const handleClose = () => {
        setOpen(false);
        onClose === null || onClose === void 0 ? void 0 : onClose();
    };
    return (React__default["default"].createElement(React__default["default"].Fragment, null,
        children,
        variant === "non-intrusive" && open && (React__default["default"].createElement(NonIntrusive, Object.assign({}, notification, { open: open, handleClose: handleClose }))),
        variant === "intrusive" && (React__default["default"].createElement(Intrusive, Object.assign({}, notification, { open: open, onHandleClose: handleClose })))));
};

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

const NerdHeadingIcon = ({ icon, color, iconPosition, }) => {
    return (React__default["default"].createElement(Grid__default["default"], { item: true, sx: { order: iconPosition === "left" ? 0 : 1, color: color } }, icon));
};

let theme = styles.createTheme({
    typography: {},
});
theme = styles.responsiveFontSizes(theme);
const ConditionalWrapper = ({ condition, wrapper, children, }) => (React__default["default"].createElement(styles.ThemeProvider, { theme: theme }, condition ? wrapper(children) : children));

const NerdHeadingComposed = (props) => {
    const { text, display, variant, classes, icon, color, children, iconPosition = "left", spacing = 1, alignItems = "center", uppercase } = props, rest = __rest(props, ["text", "display", "variant", "classes", "icon", "color", "children", "iconPosition", "spacing", "alignItems", "uppercase"]);
    return (React__default["default"].createElement(ConditionalWrapper, { condition: (text !== "" || typeof children === "string") && icon !== undefined, wrapper: (childrenContent) => (React__default["default"].createElement(Grid__default["default"], { container: true, spacing: spacing, alignItems: alignItems }, childrenContent)) },
        React__default["default"].createElement(React__default["default"].Fragment, null,
            icon && React__default["default"].createElement(NerdHeadingIcon, Object.assign({}, { icon, color, iconPosition })),
            typeof children === "object" && (React__default["default"].createElement(NerdHeadingIcon, Object.assign({ icon: children }, { color, iconPosition }))),
            (typeof children === "string" || text) && (React__default["default"].createElement(Grid__default["default"], { item: true },
                React__default["default"].createElement(Typography__default["default"], Object.assign({ display: display, variant: variant, classes: classes, color: color, textTransform: uppercase ? "uppercase" : undefined }, rest), typeof children === "string" ? children : text))))));
};

const NerdHeading = (props) => {
    const _a = props, { children, spacing, alignItems } = _a, rest = __rest(_a, ["children", "spacing", "alignItems"]);
    if (React.Children.count(children) > 0) {
        return (React__default["default"].createElement(Grid__default["default"], { container: true, spacing: spacing, alignItems: alignItems }, React.Children.map(children, (child) => {
            return React__default["default"].createElement(NerdHeadingComposed, Object.assign({}, rest), child);
        })));
    }
    return React__default["default"].createElement(NerdHeadingComposed, Object.assign({}, rest));
};

const NerdHelp = ({ explanation, classes, children, anchorOrigin = {
    vertical: "top",
    horizontal: "left",
}, transformOrigin = {
    vertical: "bottom",
    horizontal: "left",
}, variant = "body1", }) => {
    const [anchorEl, setAnchorEl] = React__default["default"].useState(null);
    const htmlRef = React.useRef(null);
    const open = Boolean(anchorEl);
    const onMouseEnter = () => {
        setAnchorEl(htmlRef.current);
    };
    const onMouseLeave = () => {
        setAnchorEl(null);
    };
    return (React__default["default"].createElement(React__default["default"].Fragment, null,
        React__default["default"].createElement(Box__default$1["default"], { ref: htmlRef, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave }, children),
        React__default["default"].createElement(StyledPopover, { sx: {
                pointerEvents: "none",
            }, open: open, anchorEl: anchorEl, anchorOrigin: anchorOrigin, transformOrigin: transformOrigin, classes: Object.assign({}, classes) },
            React__default["default"].createElement(NerdHeading, { variant: variant, text: explanation, sx: { p: 1 } }))));
};
const StyledPopover = system.styled(Popover__default["default"], {
    name: "StyledPopover",
    slot: "Wrapper",
})(() => ({
    width: "100%",
}));

const NerdCard = styles.styled(Paper__default["default"])(({ theme }) => ({
    borderRadius: theme.spacing(1),
    border: `solid 1px ${theme.palette.divider}`,
    padding: theme.spacing(2),
    borderLeft: `solid 4px ${theme.palette.primary.main}`,
    position: "relative",
    width: "100%",
}));

exports.InputAux = void 0;
(function (InputAux) {
    InputAux["REQUIRED"] = "required";
})(exports.InputAux || (exports.InputAux = {}));
exports.AutocompleteType = void 0;
(function (AutocompleteType) {
    AutocompleteType["CUSTOMER"] = "customer";
    AutocompleteType["ADDRESS"] = "address";
})(exports.AutocompleteType || (exports.AutocompleteType = {}));
exports.AutocompleteOnLoadHeading = void 0;
(function (AutocompleteOnLoadHeading) {
    AutocompleteOnLoadHeading["CUSTOMER"] = "Type a Customer Name...";
    AutocompleteOnLoadHeading["ADDRESS"] = "Type a Location Name or an Address...";
})(exports.AutocompleteOnLoadHeading || (exports.AutocompleteOnLoadHeading = {}));

const NerdDate = ({ label = "", placeholder = "", helperText = " ", required = false, variant = "standard", onChange, value, }) => {
    return (React__default["default"].createElement(LocalizationProvider.LocalizationProvider, { dateAdapter: AdapterMoment.AdapterMoment },
        React__default["default"].createElement(MobileDatePicker.MobileDatePicker, { label: label, value: value, onChange: onChange, minDate: moment__default["default"](), renderInput: (params) => (React__default["default"].createElement(TextField__default["default"], Object.assign({}, params, { variant: variant, placeholder: placeholder, InputLabelProps: {
                    shrink: true,
                }, helperText: required ? exports.InputAux.REQUIRED : helperText, required: required, fullWidth: true }))) })));
};

const NerdText = ({ label = "", placeholder = "", id, variant = "standard", required, disabled, error, helperText, value, onChange, onKeyPress, onBlur, onClick, }) => {
    return (React__default["default"].createElement(TextField__default["default"], { error: error, "aria-haspopup": "true", disabled: disabled, id: id, label: label, placeholder: placeholder, fullWidth: true, helperText: required ? exports.InputAux.REQUIRED : helperText, required: required, value: value, onChange: onChange, onKeyPress: onKeyPress, onBlur: onBlur, onClick: onClick, InputLabelProps: {
            shrink: true,
        }, variant: variant, className: required ? "Nerd-Text--required" : "", sx: {
            "& .MuiInputLabel-root": {
                display: "flex",
            },
        } }));
};

const NerdPassword = ({ label = "", placeholder = "", id, variant = "standard", required = false, disabled, error, helperText, value, onChange, }) => {
    return (React__default["default"].createElement(TextField__default["default"], { required: required, error: error, "aria-haspopup": "true", disabled: disabled, id: id, label: label, placeholder: placeholder, fullWidth: true, helperText: required ? required : helperText, value: value, onChange: onChange, InputLabelProps: {
            shrink: true,
        }, variant: variant, type: "password" }));
};

const NerdInput = (_a) => {
    var { type = "text" } = _a, props = __rest(_a, ["type"]);
    const [close, setClose] = React.useState(false);
    const { icon, spacing = 1, disabled, fullWidth, alignItems = "center", inputSize = 6, onChange, } = props;
    const sizeWithIcons = fullWidth ? 11 : inputSize;
    const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
    return (React__default["default"].createElement(ConditionalWrapper, { condition: icon !== undefined, wrapper: (childrenContent) => (React__default["default"].createElement(Grid__default["default"], { container: true, spacing: spacing, alignItems: alignItems }, childrenContent)) },
        React__default["default"].createElement(React__default["default"].Fragment, null,
            icon && React__default["default"].createElement(Grid__default["default"], { item: true }, icon),
            React__default["default"].createElement(Grid__default["default"], { item: true, sm: customInputSize, xs: icon ? 9 : 12 }, renderNerdInputByType({ type, props, close, setClose, onChange })),
            icon && (React__default["default"].createElement(Grid__default["default"], { item: true },
                React__default["default"].createElement(IconButton__default["default"], { disabled: disabled, size: "small", onClick: () => setClose(true) },
                    React__default["default"].createElement(CloseIcon__default["default"], null)))))));
};
/**
 * @param auxProps
 * @param auxProps.type
 * @param auxProps.props
 * @param auxProps.close
 * @param auxProps.setClose
 * @param auxProps.onChange
 */
function renderNerdInputByType(auxProps) {
    const { type, props } = auxProps;
    switch (type) {
        case "date":
            return React__default["default"].createElement(NerdDate, Object.assign({}, props));
        case "text":
            return React__default["default"].createElement(NerdText, Object.assign({}, props));
        case "password":
            return React__default["default"].createElement(NerdPassword, Object.assign({}, props));
        default:
            return React__default["default"].createElement(NerdText, Object.assign({}, props));
    }
}

/**
 * Function to that create a unique id
 *
 * @returns {string} - A unique id as string
 */
function uid() {
    const head = Date.now().toString(36);
    const tail = Math.random().toString(36).slice(2);
    return `${head}${tail}`;
}
/**
 * @param value
 */
function setAxeValue(value) {
    if (!value) {
        return "-";
    }
    return value.toLowerCase().replace(/\s/g, "-");
}

/**
 * @param { React.HTMLAttributes<HTMLElement> } paperProps - Autocomplete props onLoad
 * @returns { React.ReactElement } - Render react Autocomplete component onLoad
 */
function PaperComponentOnLoad(paperProps) {
    const { className, inputValue, loading, autocompleteType } = paperProps, other = __rest(paperProps, ["className", "inputValue", "loading", "autocompleteType"]);
    return (React__default["default"].createElement(Paper__default["default"], Object.assign({}, other, { className: className ? "autocompleteSmall" : "" }),
        React__default["default"].createElement(ClickAwayListener__default["default"], { onClickAway: () => console.log("onClick") },
            React__default["default"].createElement(React__default["default"].Fragment, null, inputValue && loading ? (React__default["default"].createElement(WrapperCustomerOnload, null,
                React__default["default"].createElement(CircularProgress__default["default"], { color: "primary", size: 40 }),
                React__default["default"].createElement(NerdHeading, { text: "loading", variant: "h6" }))) : (contentOnLoad(autocompleteType, inputValue, loading))))));
}
const CustomerOnload = () => {
    return (React__default["default"].createElement(WrapperCustomerOnload, null,
        React__default["default"].createElement(PersonSearchIcon__default["default"], { fontSize: "large" }),
        React__default["default"].createElement(NerdHeading, { text: exports.AutocompleteOnLoadHeading.CUSTOMER, variant: "h6" })));
};
const AdrressOnload = () => {
    return (React__default["default"].createElement(React__default["default"].Fragment, null,
        React__default["default"].createElement(WrapperCustomerOnload, null,
            React__default["default"].createElement(MapTwoToneIcon__default["default"], { fontSize: "large" }),
            React__default["default"].createElement(NerdHeading, { text: exports.AutocompleteOnLoadHeading.ADDRESS, variant: "h6" })),
        React__default["default"].createElement(material.Divider, null),
        React__default["default"].createElement(Grid__default["default"], { container: true, alignItems: "center", justifyContent: "center" },
            React__default["default"].createElement(Grid__default["default"], { item: true, py: 1 },
                React__default["default"].createElement(material.Typography, { display: "block", variant: "caption", color: "textSecondary" },
                    "Powered by ",
                    React__default["default"].createElement("b", null, "Google"),
                    " and ",
                    React__default["default"].createElement("b", null, "Archer"))))));
};
const WrapperCustomerOnload = (props) => {
    return (React__default["default"].createElement(material.Stack, { direction: "column", justifyContent: "center", alignItems: "center", spacing: 2, py: 7 }, props.children));
};
/**
 * @param {any} args - content onLoad args
 * @returns {void}
 */
function contentOnLoad(...args) {
    return args.map((arg, i) => {
        if (i === 0 && typeof arg === "string" && arg !== "") {
            switch (arg) {
                case exports.AutocompleteType.CUSTOMER:
                    return React__default["default"].createElement(CustomerOnload, { key: uid() });
                case exports.AutocompleteType.ADDRESS:
                    return React__default["default"].createElement(AdrressOnload, { key: uid() });
            }
        }
        return React__default["default"].createElement(React__default["default"].Fragment, { key: uid() });
    });
}

const RenderTemplate = ({ props, option, autocompleteType, className = "", optionsArray = [], onClick, }) => {
    const ListFoot = () => {
        return optionsArray[optionsArray.length - 1] === option ? (React__default["default"].createElement(React__default["default"].Fragment, null,
            React__default["default"].createElement(Divider__default["default"], null),
            React__default["default"].createElement(Grid__default["default"], { container: true, alignItems: "center", justifyContent: "center" },
                React__default["default"].createElement(Grid__default["default"], { item: true, py: 1 },
                    React__default["default"].createElement(Typography__default["default"], { display: "block", variant: "caption", color: "textSecondary" },
                        "Powered by ",
                        React__default["default"].createElement("b", null, "Google"),
                        " and ",
                        React__default["default"].createElement("b", null, "Archer")))))) : null;
    };
    return (React__default["default"].createElement(React__default["default"].Fragment, null,
        React__default["default"].createElement(Box__default["default"], Object.assign({ key: toolkit.nanoid(), component: "li", sx: {
                backgroundColor: "transparent",
                svg: { flexShrink: 0, color: "white" },
                cursor: "pointer",
                "&:hover": {
                    backgroundColor: "rgba(0, 0, 0, 0.08)",
                },
            } }, props, { className: className, onClick: onClick }),
            React__default["default"].createElement(CardHeader__default["default"], { avatar: React__default["default"].createElement(Avatar__default["default"], { sx: {
                        bgcolor: setTemplateIconColorByType(autocompleteType, option),
                    }, "aria-label": autocompleteType }, setTemplateIconByType(autocompleteType)), title: setTemplateTitle(autocompleteType, option), titleTypographyProps: { fontWeight: "500", variant: "body1" }, subheader: setTemplateContentByType(autocompleteType, option), sx: {
                    py: 1,
                    px: 1,
                } })),
        React__default["default"].createElement(ListFoot, null)));
};
/**
 *
 * @param type
 */
function setTemplateIconByType(type) {
    switch (type) {
        case exports.AutocompleteType.CUSTOMER:
            return React__default["default"].createElement(CorporateFareIcon__default["default"], { fontSize: "medium" });
        case exports.AutocompleteType.ADDRESS:
            return React__default["default"].createElement(LocationOnTwoToneIcon__default["default"], { fontSize: "medium" });
        default:
            return React__default["default"].createElement(CorporateFareIcon__default["default"], { fontSize: "medium" });
    }
}
/**
 *
 * @param type
 * @param option
 */
function setTemplateIconColorByType(type, option) {
    switch (type) {
        case exports.AutocompleteType.CUSTOMER:
            return colors.blue[500];
        case exports.AutocompleteType.ADDRESS:
            if (option.name) {
                return colors.blue[500];
            }
            return colors.grey[500];
        default:
            return colors.blue[500];
    }
}
/**
 *
 * @param type
 * @param option
 */
function setTemplateContentByType(type, option) {
    const auxContentCredit = option.credit_on_hold ? " - ( Credit Hold )" : "";
    const auxContentInactivity = option.inactivity_hold
        ? " - ( Inactivity Hold )"
        : "";
    switch (type) {
        case exports.AutocompleteType.CUSTOMER:
            return `${option.line1} ${option.state} ${option.zip} ${auxContentCredit} ${auxContentInactivity}`;
        case exports.AutocompleteType.ADDRESS:
            if (option.structured_formatting) {
                return `${option.structured_formatting.secondary_text}`;
            }
            return option.name;
        default:
            return "";
    }
}
/**
 *
 * @param type
 * @param option
 */
function setTemplateTitle(type, option) {
    switch (type) {
        case exports.AutocompleteType.CUSTOMER:
            return `${option.name}`;
        case exports.AutocompleteType.ADDRESS:
            if (option.structured_formatting) {
                return `${option.structured_formatting.main_text}`;
            }
            return option.name;
        default:
            return "";
    }
}

/* eslint-disable @typescript-eslint/no-explicit-any */
const NerdAutoComplete = ({ itemID, value, fullWidth, onChange, onInputChange, inputValue, label, placeholder, options = [], variant = "standard", required = false, helperText, loading, autocompleteType = exports.AutocompleteType.CUSTOMER, icon, spacing = 1, alignItems = "center", disabled = false, 
//inputSize = 6,
autoCompleteOptionLabel = "", className, isEditable = false, }) => {
    const [open, setOpen] = React.useState(false);
    // const sizeWithIcons = fullWidth ? 11 : inputSize;
    //const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
    return (React__default["default"].createElement(ConditionalWrapper, { condition: icon !== undefined, wrapper: (childrenContent) => (React__default["default"].createElement(Grid__default["default"], { container: true, spacing: spacing, alignItems: alignItems }, childrenContent)) },
        React__default["default"].createElement(React__default["default"].Fragment, null,
            icon && React__default["default"].createElement(Grid__default["default"], { item: true }, icon),
            React__default["default"].createElement(Grid__default["default"], { item: true, sm: true },
                React__default["default"].createElement(Autocomplete__default["default"], { id: itemID, open: open, value: value, fullWidth: fullWidth, onOpen: () => setOpen(true), onClose: () => setOpen(false), onChange: onChange, onInputChange: onInputChange, inputValue: inputValue, options: options, clearIcon: null, getOptionLabel: (option) => getOptionLabel(option, autoCompleteOptionLabel), onKeyDown: (event) => {
                        if (event.key === "Enter") {
                            // Prevent's default 'Enter' behavior.
                            event.preventDefault();
                            // handler code
                        }
                    }, renderInput: (params) => (React__default["default"].createElement(TextField__default["default"], Object.assign({}, params, { label: label, variant: variant, placeholder: placeholder, InputLabelProps: {
                            shrink: true,
                        }, InputProps: Object.assign(Object.assign({}, params.InputProps), { endAdornment: null }), helperText: renderHelperText(required, helperText), required: required, fullWidth: true }))), renderOption: (props, option) => {
                        return (React__default["default"].createElement(RenderTemplate, Object.assign({}, props, { option: option, autocompleteType: autocompleteType, optionsArray: options })));
                    }, PaperComponent: (props) => {
                        if (!inputValue || loading) {
                            return (React__default["default"].createElement(PaperComponentOnLoad, Object.assign({}, { props, inputValue, autocompleteType, loading }, { key: toolkit.nanoid(), className: className ? "autocompleteSmall" : "" })));
                        }
                        return (React__default["default"].createElement(Paper__default["default"], Object.assign({}, props, { key: toolkit.nanoid(), className: className ? "autocompleteSmall" : "" }), props.children));
                    } })),
            icon && (React__default["default"].createElement(Grid__default["default"], { item: true, flexDirection: "column", display: "flex" },
                isEditable && (React__default["default"].createElement(IconButton__default["default"], { disabled: disabled, size: "small", onClick: (event) => {
                        setOpen(false);
                        onChange(event, "");
                        onInputChange(event, "");
                    } },
                    React__default["default"].createElement(EditIcon__default["default"], { fontSize: "small" }))),
                React__default["default"].createElement(IconButton__default["default"], { disabled: disabled, size: "small", onClick: (event) => {
                        setOpen(false);
                        onChange(event, "");
                        onInputChange(event, "");
                    } },
                    React__default["default"].createElement(CloseIcon__default["default"], { fontSize: "small" })))))));
};
/**
 *
 * @param required
 * @param helperText
 */
function renderHelperText(required, helperText) {
    if (!helperText) {
        return "";
    }
    return required ? exports.InputAux.REQUIRED : helperText;
}
/**
 *
 * @param option
 * @param autoCompleteOptionLabel
 */
function getOptionLabel(option, autoCompleteOptionLabel) {
    if (typeof option === "string") {
        return option;
    }
    if (typeof option === "object" && Object.keys(option).length > 0) {
        return option[autoCompleteOptionLabel];
    }
    return "";
}

/**
 * DataGrid string filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} TextField input for boolean type filter.
 */
function StringOperatorInput(props) {
    const { item, applyValue, focusElementRef } = props;
    const ref = React__default["default"].useRef(null);
    React__default["default"].useImperativeHandle(focusElementRef, () => ({
        focus: () => {
            var _a, _b;
            (_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.querySelector(`input[value="${item.value || ""}"]`)) === null || _b === void 0 ? void 0 : _b.focus();
        },
    }));
    const handleFilterChange = (event) => {
        applyValue(Object.assign(Object.assign({}, item), { value: event.target.value }));
    };
    return (React__default["default"].createElement(material.TextField, { name: "custom-filter-operator", placeholder: "Value", label: "Value", variant: "standard", InputLabelProps: {
            shrink: true,
        }, value: item.value || "", onChange: (e) => handleFilterChange(e), ref: ref }));
}

/**
 * DataGrid date filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} DatePicker input for date type filter.
 */
function DateOperatorInput(props) {
    const { item, applyValue, focusElementRef } = props;
    const ref = React__default["default"].useRef(null);
    React__default["default"].useImperativeHandle(focusElementRef, () => ({
        focus: () => {
            var _a, _b;
            (_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.querySelector(`input[value="${item.value || ""}"]`)) === null || _b === void 0 ? void 0 : _b.focus();
        },
    }));
    const handleFilterChange = (value) => {
        applyValue(Object.assign(Object.assign({}, item), { value: value ? value.format("YYYY-MM-DD") : "" }));
    };
    return (React__default["default"].createElement(LocalizationProvider.LocalizationProvider, { dateAdapter: AdapterMoment.AdapterMoment },
        React__default["default"].createElement(DatePicker.DatePicker, { inputFormat: "YYYY/MM/DD", mask: "____/__/__", label: "Value", value: item.value || "", onChange: (value) => handleFilterChange(value), ref: ref, renderInput: (params) => (React__default["default"].createElement(material.TextField, Object.assign({}, params, { placeholder: "Value", label: "Value", variant: "standard" }))) })));
}

/**
 * DataGrid boolean filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} CheckBox input for boolean type filter.
 */
function BoolOperatorInput(props) {
    const { item, applyValue, focusElementRef } = props;
    const ref = React__default["default"].useRef(null);
    React__default["default"].useImperativeHandle(focusElementRef, () => ({
        focus: () => {
            var _a, _b;
            (_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.querySelector(`input[value="${item.value || ""}"]`)) === null || _b === void 0 ? void 0 : _b.focus();
        },
    }));
    const handleFilterChange = (event) => {
        applyValue(Object.assign(Object.assign({}, item), { value: event.target.checked }));
    };
    return (React__default["default"].createElement(material.FormGroup, { sx: { justifyContent: "center" } },
        React__default["default"].createElement(material.FormControlLabel, { control: React__default["default"].createElement(material.Checkbox, { name: "custom-filter-operator", placeholder: "Value", checked: item.value || false, onChange: (e) => handleFilterChange(e) }), label: "Active" })));
}

const CustomArrow = ({ onPageChange, page, disabledNext, children, }) => {
    const disablePrev = page === 1;
    return (React__default["default"].createElement(material.Box, null,
        React__default["default"].createElement(material.Tooltip, { title: "First Page", placement: "bottom", enterDelay: 300 },
            React__default["default"].createElement("span", null,
                React__default["default"].createElement(material.IconButton, { onClick: (e) => onPageChange(e, 1), disabled: disablePrev, "aria-label": "First Page" },
                    React__default["default"].createElement(iconsMaterial.FirstPage, null)))),
        React__default["default"].createElement(material.Tooltip, { title: "Prev Page", placement: "bottom", enterDelay: 300 },
            React__default["default"].createElement("span", null,
                React__default["default"].createElement(material.IconButton, { onClick: (e) => onPageChange(e, page - 1), disabled: disablePrev, "aria-label": "Previous Page" },
                    React__default["default"].createElement(iconsMaterial.KeyboardArrowLeft, null)))),
        children,
        React__default["default"].createElement(material.Tooltip, { title: "Next Page", placement: "bottom", enterDelay: 300 },
            React__default["default"].createElement("span", null,
                React__default["default"].createElement(material.IconButton, { onClick: (e) => {
                        onPageChange(e, page + 1);
                    }, "aria-label": "Next Page", disabled: disabledNext },
                    React__default["default"].createElement(iconsMaterial.KeyboardArrowRight, null))))));
};

const PageActions = (props) => {
    const { page, onPageChange, selectPages, disabledNext } = props;
    const pagesStored = [
        ...Array.from(new Set(selectPages.sort((a, b) => a - b))),
    ];
    const theme = material.useTheme();
    const matches = material.useMediaQuery(theme.breakpoints.down("sm"));
    return (React__default["default"].createElement(Grid__default["default"], { container: true, alignItems: "center", className: "paginationContainer", sx: { marginLeft: "1rem" } },
        React__default["default"].createElement(Grid__default["default"], { item: true },
            React__default["default"].createElement(CustomArrow, Object.assign({}, {
                onPageChange,
                page,
                disabledNext,
                pagesStored,
            }),
                React__default["default"].createElement(Pagination__default["default"], { count: pagesStored[pagesStored.length - 1], defaultPage: page, siblingCount: matches ? 0 : 1, size: matches ? "small" : "medium", hideNextButton: true, hidePrevButton: true, sx: {
                        display: "inline",
                        "&.MuiPagination-root *": {
                            display: "inline",
                        },
                    }, onChange: (event, page) => {
                        onPageChange(event, page);
                    } })))));
};

exports.nerdPaginationAuxContent = void 0;
(function (nerdPaginationAuxContent) {
    nerdPaginationAuxContent["Rows"] = "Rows";
})(exports.nerdPaginationAuxContent || (exports.nerdPaginationAuxContent = {}));

const NerdPagination = ({ page, rowsPerPage, rowPageOptions, selectPages, disabledNext, handleChangePage, handleChangeRowsPerPage, }) => {
    const theme = styles.useTheme();
    const matches = useMediaQuery__default["default"](theme.breakpoints.down("sm"));
    return (React__default["default"].createElement(TablePagination__default["default"], { component: "div", count: -1, page: page, onPageChange: handleChangePage, rowsPerPage: rowsPerPage, rowsPerPageOptions: rowPageOptions, onRowsPerPageChange: handleChangeRowsPerPage, ActionsComponent: (props) => (React__default["default"].createElement(PageActions, Object.assign({ selectPages: selectPages, disabledNext: disabledNext }, props))), labelDisplayedRows: () => {
            return "";
        }, labelRowsPerPage: exports.nerdPaginationAuxContent.Rows, getItemAriaLabel: (type) => `Go to ${type} page`, backIconButtonProps: {
            "aria-label": "Previous Page",
        }, nextIconButtonProps: {
            "aria-label": "Next Page",
        }, className: `nerdUI--pagination ${matches ? "nerdUI--pagination-sm" : ""}` }));
};

const OPERATORS = {
    eq: {
        label: "Equal",
        value: "eq",
    },
    neq: {
        label: "Not Equal",
        value: "neq",
    },
    gt: {
        label: "Greater Than",
        value: "gt",
    },
    lt: {
        label: "Less Than",
        value: "lt",
    },
    gte: {
        label: "Greater or Equal Than",
        value: "gte",
    },
    lte: {
        label: "Less or Equal Than",
        value: "lte",
    },
    like: {
        label: "Like",
        value: "like",
    },
};
/**
 * NerdGrid component.
 *
 * @param {propsType} props nerdGrid props.
 * @returns {React.ReactElement} DataGrid wrapper with server-side filters.
 */
function NerdGrid(props) {
    const { columnsVisibility, columns, networkCompletionStack, dispatch, queryBuilder, getRows, culumnsMatchingFilterName, hidePagination, hideFilters, defaultSelectRowID, createNewButton, } = props;
    const rows = props.rows;
    const rowPageOptions = React.useMemo(() => [10, 50, 100], []);
    let limit;
    let offset;
    let filters;
    if (queryBuilder) {
        const queryParams = queryBuilder.getQuery();
        limit = queryParams["limit"];
        offset = queryParams["offset"];
        filters = queryParams["filters"];
    }
    const [rowsPerPage, setRowsPerPage] = React.useState(10);
    const [page, setPage] = React.useState(1);
    const [selectPages, setSelectPages] = React.useState([0]);
    const [disabledNext, setDisabledNext] = React.useState(false);
    const [rowCount, setRowCount] = React__default["default"].useState(undefined);
    const [rowCountState, setRowCountState] = React__default["default"].useState(rowCount || 0);
    const [queryObject, setQueryObject] = React.useState(culumnsMatchingFilterName
        ? {
            filters: filters ? filters : "",
            limit: Number(limit) ? Number(limit) : rowsPerPage,
            offset: Number(offset) ? Number(offset) : 0,
        }
        : {
            limit: Number(limit) ? Number(limit) : rowsPerPage,
            offset: Number(offset) ? Number(offset) : 0,
        });
    const [requestPending, setRequestPending] = React.useState(false);
    const [requestUUID, setRequestUUID] = React.useState("");
    const [filterModel, setFilterModel] = React.useState({
        items: [],
        linkOperator: xDataGridPro.GridLinkOperator.And,
    });
    const [selectionModel, setSelectionModel] = React.useState(defaultSelectRowID &&
        rows.filter((row) => row["id"] === defaultSelectRowID).length > 0
        ? [defaultSelectRowID]
        : []);
    const prevSelectionModel = React__default["default"].useRef(defaultSelectRowID ? [defaultSelectRowID] : []);
    /**
     * Custom MUI Grid Toolbar
     *
     * @returns {React.ReactElement} Mui Grid Toolbar
     */
    function CustomToolbar() {
        return (React__default["default"].createElement(xDataGridPro.GridToolbarContainer, null,
            !hideFilters && React__default["default"].createElement(xDataGridPro.GridToolbarFilterButton, null),
            props.apiExportEndpoint && (React__default["default"].createElement(material.Button, { sx: { fontSize: "0.8125rem" }, variant: "text", startIcon: React__default["default"].createElement(iconsMaterial.SaveAlt, null), onClick: () => {
                    const a = encodeURI(`${props.apiExportEndpoint}${"filters" in queryObject
                        ? `?filters=${queryObject.filters}`
                        : ""}`);
                    window.open(a, "_blank", "noopener,noreferrer");
                } }, "EXPORT")),
            createNewButton));
    }
    React.useEffect(() => {
        try {
            if (culumnsMatchingFilterName && filters) {
                const filtersObject = JSON.parse(filters);
                const filterModelTmp = {
                    items: [],
                    linkOperator: xDataGridPro.GridLinkOperator.And,
                };
                Array.isArray(filtersObject) &&
                    filtersObject.forEach((filter, i) => {
                        let columnField = "";
                        for (const [key, value] of culumnsMatchingFilterName.entries()) {
                            if (value === filter.name)
                                columnField = key;
                        }
                        filterModelTmp.items.push({
                            id: i + 1,
                            columnField,
                            value: filter.value,
                            operatorValue: filter.comparison,
                        });
                    });
                setFilterModel(filterModelTmp);
            }
        }
        catch (error) {
            return;
        }
    }, []);
    // Set URL query
    React.useEffect(() => {
        if (queryBuilder) {
            if (Number(offset) % Number(limit) !== 0 ||
                !rowPageOptions.includes(Number(limit))) {
                setQueryObject(Object.assign(Object.assign({}, queryObject), { limit: 10, offset: 0 }));
                setPage(1);
                setRowsPerPage(10);
            }
            else if (Number(limit) === queryObject.limit) {
                setPage(Number(offset) / Number(limit) + 1);
                setRowsPerPage(Number(limit));
            }
            queryBuilder.setUrlQuery(queryObject);
        }
    }, [offset, limit, rowPageOptions, queryObject, queryBuilder]);
    /**
     * Return DataGrid filter operators for a given column type.
     *
     * @param {string | undefined} type Type of the column.
     * @returns {Array<GridFilterOperator>} Return filter operators.
     */
    function operatorsByType(type) {
        const operators = [];
        let input;
        switch (type) {
            case "date":
                input = DateOperatorInput;
                break;
            case "boolean":
                input = BoolOperatorInput;
                break;
            default:
                input = StringOperatorInput;
                break;
        }
        Object.entries(OPERATORS).forEach((val) => operators.push({
            label: val[1].label,
            value: val[1].value,
            getApplyFilterFn: () => {
                //ServerSide filter, so we don't need filter function here.
                return () => {
                    return true;
                };
            },
            InputComponent: input,
        }));
        return operators;
    }
    const setCustomPagination = React.useCallback(() => {
        if (Number(offset) > 0 || Number(limit) > 0) {
            setSelectPages((prevState) => [
                ...Array.from(new Set(prevState)),
                ...Array(page)
                    .fill(0)
                    .map((_e, i) => i + 1),
            ]);
        }
    }, [limit, offset, page]);
    const columnsWithOperators = React__default["default"].useMemo(() => columns.map((col) => {
        return Object.assign(Object.assign({}, col), { filterOperators: operatorsByType(col.type) });
    }), [columns]);
    React.useEffect(() => {
        if (dispatch && getRows) {
            setRequestPending(true);
            setRowCount(undefined);
            const uuid = nerdNetwork.withNetworkCompletionDispatch(dispatch, getRows(queryObject));
            setRequestUUID(uuid);
        }
    }, [dispatch, getRows, queryObject]);
    // Check if API call ends and close loading
    React.useEffect(() => {
        if (networkCompletionStack) {
            if (requestUUID !== "" &&
                !networkCompletionStack.some((e) => e[requestUUID])) {
                setRequestUUID("");
                setRequestPending(false);
                setRowCount(rows.length);
                //restore selection model after page change
                setSelectionModel(prevSelectionModel.current);
            }
            setCustomPagination();
        }
    }, [requestUUID, networkCompletionStack, setCustomPagination, rows.length]);
    const onFilterChange = React__default["default"].useCallback((newFilterModel) => {
        if (culumnsMatchingFilterName) {
            const filters = [];
            newFilterModel.items.forEach((item) => {
                const searchMetadataName = culumnsMatchingFilterName.get(item.columnField);
                if (item.operatorValue &&
                    item.value !== undefined &&
                    item.value !== "" &&
                    searchMetadataName) {
                    filters.push({
                        name: searchMetadataName,
                        comparison: item.operatorValue,
                        value: item.value,
                    });
                }
            });
            setPage(1); // Reset page to 1
            setSelectPages([0]); // Reset select pages
            setQueryObject({
                limit: queryObject.limit,
                offset: 0,
                filters: JSON.stringify(filters),
            });
            setFilterModel(newFilterModel);
        }
    }, [culumnsMatchingFilterName, queryObject.limit]);
    /**
     * Set new page value and change the query object
     *
     * @param {React.MouseEvent<HTMLButtonElement> | null} _event ChangePage
     * @param {number} newPage New page index
     */
    function handleChangePage(_event, newPage) {
        prevSelectionModel.current = selectionModel;
        setPage(newPage);
        if (newPage > 0) {
            setQueryObject(Object.assign(Object.assign({}, queryObject), { offset: (newPage - 1) * Number(limit) }));
        }
    }
    /**
     * @param {ChangeEvent<HTMLInputElement | HTMLTextAreaElement>} event - new rows page number selected
     */
    function handleChangeRowsPerPage(event) {
        const newPage = parseInt(event.target.value, 10);
        setRowsPerPage(newPage); // set new page size
        setPage(1); // Reset page to 1
        setSelectPages([0]); // Reset select pages
        // Set new query object
        setQueryObject((prevState) => (Object.assign(Object.assign({}, prevState), { limit: newPage, offset: 0 })));
    }
    /**
     *
     * @param {GridSelectionModel} ids Selected rows
     */
    function onSelectionModelChange(ids) {
        var _a, _b;
        const selectedIDs = new Set(ids);
        const selectedRows = rows.filter((row) => selectedIDs.has(row.id));
        const prevSelectedIDs = new Set(prevSelectionModel.current);
        //Don't call onSelect if page changed
        if (ids.length === 0) {
            if (rows.filter((row) => prevSelectedIDs.has(row.id)).length > 0) {
                (_a = props.onSelect) === null || _a === void 0 ? void 0 : _a.call(props, selectedRows);
            }
        }
        else {
            (_b = props.onSelect) === null || _b === void 0 ? void 0 : _b.call(props, selectedRows);
        }
        setSelectionModel(ids);
    }
    React__default["default"].useEffect(() => {
        setRowCountState((prevRowCountState) => rowCount !== undefined ? rowCount : prevRowCountState);
    }, [rowCount, setRowCountState]);
    return (React__default["default"].createElement(xDataGridPro.DataGridPro, { sx: {
            "&.MuiDataGrid-root .MuiDataGrid-cell:focus": {
                outline: "none",
            },
            paddingTop: "0px",
            width: "100%",
            height: "700px",
        }, pageSize: rowsPerPage, rowsPerPageOptions: rowPageOptions, onStateChange: (state) => {
            const { pagination: { rowCount, pageSize }, } = state;
            setDisabledNext(rowCount < pageSize);
        }, pagination: true, paginationMode: "server", rowCount: rowCountState, hideFooterPagination: hidePagination, components: {
            Toolbar: CustomToolbar,
            Pagination: NerdPagination,
        }, componentsProps: {
            filterPanel: { linkOperators: ["and"] },
            pagination: {
                rowsPerPage,
                handleChangeRowsPerPage,
                rowPageOptions,
                handleChangePage,
                page,
                selectPages,
                disabledNext,
            },
        }, onSelectionModelChange: onSelectionModelChange, rows: rows, columns: columnsWithOperators, loading: requestPending, filterMode: "server", onFilterModelChange: onFilterChange, initialState: {
            columns: {
                columnVisibilityModel: columnsVisibility,
            },
        }, filterModel: filterModel, selectionModel: selectionModel }));
}

const notificationInitialState = {
    notification: {
        uuid: "",
    },
};
const notificationSlice = toolkit.createSlice({
    name: "notification",
    initialState: notificationInitialState,
    reducers: {
        showNotification: (_state, action) => {
            return Object.assign({}, action.payload);
        },
        clearNotification: () => {
            return notificationInitialState;
        },
    },
});
const { showNotification, clearNotification } = notificationSlice.actions;
const notificationReducer = notificationSlice.reducer;

/**
 *
 * @param {PropsType} props Component props
 * @returns {ReactElement} NerdAppsMenu
 */
function NerdAppsMenu(props) {
    const { apps, homePath } = props;
    return (React__default["default"].createElement(material.Grid, { container: true, padding: "10px" },
        apps.map((app, i) => {
            var _a;
            return (React__default["default"].createElement(material.Grid, { key: (_a = app.name) === null || _a === void 0 ? void 0 : _a.concat(i.toString()), item: true, xs: 4, sm: 3 },
                React__default["default"].createElement(AppIcon, { app: app })));
        }),
        React__default["default"].createElement(material.Grid, { item: true, xs: 12, mt: 2, textAlign: "center" },
            React__default["default"].createElement(material.Button, { href: homePath, variant: "outlined", startIcon: React__default["default"].createElement(iconsMaterial.Home, null) }, "Home"))));
}
/**
 *
 * @param {object} props Component props
 * @param {App} props.app App to render
 * @returns {ReactElement} AppIcon
 */
function AppIcon(props) {
    const { app } = props;
    const [hover, setHover] = React.useState(false);
    const transition = "ease-in";
    return (React__default["default"].createElement(material.Box, { sx: {
            display: "flex",
            flexDirection: "column",
            alignContent: "center",
            alignItems: "center",
            animationDelay: `-${Math.random()}s`,
            animationDuration: `.${Math.floor(Math.random() * 11) + 20}s`,
        }, onMouseEnter: () => setHover(true), onMouseLeave: () => setHover(false) },
        app.url ? (React__default["default"].createElement("a", { href: `https://${app.url}`, style: {
                textDecoration: "none",
            } }, app.icon ? (React__default["default"].createElement("img", { src: app.icon, alt: "app_icon", width: 40, height: 40, style: {
                borderRadius: "20%",
                boxShadow: hover
                    ? "0 5px 18px 0 rgba(0,0,0,.3)"
                    : "0 5px 28px 0 rgba(0,0,0,.1)",
                transition: `box-shadow .2s ${transition}`,
            } })) : (React__default["default"].createElement(material.Box, { sx: {
                backgroundColor: app.color,
                marginBottom: "5px",
                width: "40px",
                height: "40px",
                textAlign: "center",
                border: `solid ${40 * 0.05}px ${app.color}`,
                background: "#424242",
                color: app.color,
                fontFamily: "Futura",
                fontSize: 40 * 0.5,
                borderTopRightRadius: 40 * 0.5,
                borderBottomLeftRadius: 40 * 0.5,
                boxShadow: hover
                    ? "0 5px 18px 0 rgba(0,0,0,.3)"
                    : "0 5px 28px 0 rgba(0,0,0,.1)",
                transition: `box-shadow .2s ${transition}`,
            } },
            React__default["default"].createElement(material.Grid, { container: true, justifyContent: "center", alignItems: "center", style: { height: 35 } }, app.name && React__default["default"].createElement(material.Grid, { item: true }, `${app.name[0]}${app.name[1]}`)))))) : null,
        React__default["default"].createElement(material.Typography, { fontWeight: "300", fontSize: "14px", textAlign: "center" }, app.name)));
}

exports.ConditionalWrapper = ConditionalWrapper;
exports.NerdAppsMenu = NerdAppsMenu;
exports.NerdAutoComplete = NerdAutoComplete;
exports.NerdCard = NerdCard;
exports.NerdGrid = NerdGrid;
exports.NerdHeading = NerdHeading;
exports.NerdHelp = NerdHelp;
exports.NerdIcon = NerdIcon;
exports.NerdInput = NerdInput;
exports.NerdNotifier = NerdNotifier;
exports.NerdPagination = NerdPagination;
exports.PaperComponentOnLoad = PaperComponentOnLoad;
exports.RenderTemplate = RenderTemplate;
exports.clearNotification = clearNotification;
exports.colorSwitch = colorSwitch;
exports.notificationInitialState = notificationInitialState;
exports.notificationReducer = notificationReducer;
exports.notificationSlice = notificationSlice;
exports.setAxeValue = setAxeValue;
exports.setCustomIconDefinition = setCustomIconDefinition;
exports.showNotification = showNotification;
exports.uid = uid;
//# sourceMappingURL=index.js.map
