import React from "react";
import Grid from "@mui/material/Grid";
import { INerdHeadingIconProps } from "../typings";

const NerdHeadingIcon: React.FC<INerdHeadingIconProps> = ({
  icon,
  color,
  iconPosition,
}): JSX.Element => {
  return (
    <Grid
      item
      sx={{ order: iconPosition === "left" ? 0 : 1, color: color as string }}
    >
      {icon}
    </Grid>
  );
};

export default NerdHeadingIcon;
