// Generated with util/create-component.js
import React, { Children } from "react";
import { TypographyProps } from "@mui/material/Typography";
import { NerdHeadingProps } from "./typings";
import "./NerdHeading.scss";
import { NerdHeadingComposed } from "./components/NerdHeadingComposed";
import Grid from "@mui/material/Grid";

const NerdHeading: React.FC<NerdHeadingProps & TypographyProps> = (props) => {
  const { children, spacing, alignItems, ...rest } = props as NerdHeadingProps &
    TypographyProps;

  if (Children.count(children) > 0) {
    return (
      <Grid container spacing={spacing} alignItems={alignItems}>
        {Children.map(children, (child: any) => {
          return <NerdHeadingComposed {...rest}>{child}</NerdHeadingComposed>;
        })}
      </Grid>
    );
  }

  return <NerdHeadingComposed {...rest} />;
};

export default NerdHeading;
