import React from "react";
import { ComponentStory } from "@storybook/react";
import { NerdHelp } from "./NerdHelp";

export default {
  title: "NerdHelp",
  component: NerdHelp,
  argTypes: {
    showPopover: {
      options: [{ id: 1 }, null],
      control: { type: "radio" },
    },
  },
};

export const Default: ComponentStory<typeof NerdHelp> = (args) => (
  <NerdHelp {...args} />
);

Default.args = {
  explanation: "Lorem Ipsum Icon",
};
